<?php
/**
 * 
 *
 * PHP version 8.1
 *
 * @category  Class
 * @author    Threema Gateway team
 * @copyright Copyright (c) 2024 Threema GmbH
 * @see       https://gateway.threema.ch/en/developer
 */

/**
 * Threema Gateway Php SDK
 *
 * This SDK allows for preparing, sending, and receiving Threema messages via Threema Gateway.
 *
 * Generated by: https://gateway.threema.ch/en/developer
 * MsgApi SDK Generator version: 0.1.0
 */

namespace Threema\MsgApi\Messages;

use Threema\MsgApi\Types\GroupId;

/**
 * @deprecated
 */
class GroupAudioMessage extends ThreemaGroupMessage implements \Stringable
{
	final public const TYPE_CODE = 0x45;

	private readonly GroupId $groupId;

	/**
	 * @param GroupId $groupId
	 * @param string $blobId
	 * @param int $blobLength
	 * @param string $encryptionKey
	 * @param int $duration
	 */
	public function __construct(
		GroupId                 $groupId,
		private readonly string $blobId,
			/** @var */
		private readonly int    $blobLength,
		private readonly string $encryptionKey,
		private readonly int    $duration
	) {
		parent::__construct($groupId);
		$this->groupId = $groupId;
	}

	/**
	 * @return string
	 */
	public function __toString(): string
	{
		return 'group audio message';
	}

	/**
	 * @return string
	 */
	public function getBlobId(): string
	{
		return $this->blobId;
	}

	/**
	 * @return string
	 */
	public function getEncryptionKey(): string
	{
		return $this->encryptionKey;
	}

	/**
	 * @return int|string
	 */
	public function getDuration(): int|string
	{
		return $this->duration;
	}

	/**
	 * @return int
	 */
	public function getBlobLength(): int
	{
		return $this->blobLength;
	}

	/**
	 * Get the message type code of this message.
	 *
	 * @return int message type code
	 */
	final public function getTypeCode(): int
	{
		return self::TYPE_CODE;
	}
}
