<?php
/**
 * 
 *
 * PHP version 8.1
 *
 * @category  Class
 * @author    Threema Gateway team
 * @copyright Copyright (c) 2024 Threema GmbH
 * @see       https://gateway.threema.ch/en/developer
 */

/**
 * Threema Gateway Php SDK
 *
 * This SDK allows for preparing, sending, and receiving Threema messages via Threema Gateway.
 *
 * Generated by: https://gateway.threema.ch/en/developer
 * MsgApi SDK Generator version: 0.1.0
 */

namespace Threema\MsgApi\Messages;

use Threema\MsgApi\Types\GroupId;

/**
 * @deprecated
 */
class GroupVideoMessage extends ThreemaGroupMessage implements \Stringable
{
	final public const TYPE_CODE = 0x44;

	/**
	 * @param GroupId $groupId
	 * @param string $blobId
	 * @param int $blobLength
	 * @param string $thumbnailBlobId
	 * @param int $thumbnailBlobLength
	 * @param string $encryptionKey
	 * @param int $duration
	 */
	public function __construct(
		GroupId                 $groupId,
		private readonly string $blobId,
		private readonly int    $blobLength,
		private readonly string $thumbnailBlobId,
		private readonly int    $thumbnailBlobLength,
		private readonly string $encryptionKey,
		private readonly int    $duration
	) {
		parent::__construct($groupId);
	}

	/**
	 * @return string
	 */
	public function __toString(): string
	{
		return 'group video message';
	}

	/**
	 * @return string
	 */
	public function getBlobId(): string
	{
		return $this->blobId;
	}

	/**
	 * @return int
	 */
	public function getBlobLength(): int
	{
		return $this->blobLength;
	}

	/**
	 * @return string
	 */
	public function getThumbnailBlobId(): string
	{
		return $this->thumbnailBlobId;
	}

	/**
	 * @return int
	 */
	public function getThumbnailBlobLength(): int
	{
		return $this->thumbnailBlobLength;
	}

	/**
	 * @return int
	 */
	public function getDuration(): int
	{
		return $this->duration;
	}

	/**
	 * @return string
	 */
	public function getEncryptionKey(): string
	{
		return $this->encryptionKey;
	}

	/**
	 * Get the message type code of this message.
	 *
	 * @return int message type code
	 */
	public function getTypeCode(): int
	{
		return self::TYPE_CODE;
	}
}
