<?php
/**
 * 
 *
 * PHP version 8.1
 *
 * @category  Class
 * @author    Threema Gateway team
 * @copyright Copyright (c) 2024 Threema GmbH
 * @see       https://gateway.threema.ch/en/developer
 */

/**
 * Threema Gateway Php SDK
 *
 * This SDK allows for preparing, sending, and receiving Threema messages via Threema Gateway.
 *
 * Generated by: https://gateway.threema.ch/en/developer
 * MsgApi SDK Generator version: 0.1.0
 */

namespace Threema\MsgApi\Messages;

/**
 * @deprecated
 */
class ImageMessage extends ThreemaMessage implements \Stringable
{
	final public const TYPE_CODE = 0x02;

	private ?string $caption = null;

	/**
	 * @param string $blobId
	 * @param int $length
	 * @param string $nonce
	 */
	public function __construct(
		private readonly string $blobId,
		private readonly int    $length,
		private readonly string $nonce
	) {
	}

	/**
	 * @return string
	 */
	public function __toString(): string
	{
		return 'image message';
	}

	/**
	 * @return string
	 */
	public function getBlobId(): string
	{
		return $this->blobId;
	}

	/**
	 * @return int|string
	 */
	public function getLength(): int|string
	{
		return $this->length;
	}

	/**
	 * @return int|string
	 */
	public function getNonce(): int|string
	{
		return $this->nonce;
	}

	/**
	 * @param string $caption
	 */
	public function setCaption($caption)
	{
		$this->caption = $caption;
	}

	/**
	 * @return string|null
	 */
	public function getCaption(): ?string
	{
		return $this->caption;
	}

	/**
	 * Get the message type code of this message.
	 *
	 * @return int message type code
	 */
	final public function getTypeCode(): int
	{
		return self::TYPE_CODE;
	}
}
