<?php
declare(strict_types = 1);

/**
 * ThreemaGroupMessage
 *
 * PHP version 8.1
 *
 * @category  Class
 * @author    Threema Gateway team
 * @copyright Copyright (c) 2024 Threema GmbH
 * @see       https://gateway.threema.ch/en/developer
 */

/**
 * Threema Gateway Php SDK
 *
 * This SDK allows for preparing, sending, and receiving Threema messages via Threema Gateway.
 *
 * The version of the model input document: 1
 * Generated by: https://gateway.threema.ch/en/developer
 * MsgApi SDK Generator version: 0.1.0
 */

namespace Threema\MsgApi\Messages;

use Closure;
use Threema\MsgApi\Messages\ThreemaMessage;
use Threema\MsgApi\Serializers;
use Threema\MsgApi\Tools\Util;
use Threema\MsgApi\Types\BallotId;
use Threema\MsgApi\Types\GroupId;
use Threema\MsgApi\Types\DeliveryReceiptType;
use Threema\MsgApi\Types\FileRenderingType;
use Threema\MsgApi\Types\Voting\BallotChoice;

/**
 * ThreemaGroupMessage Class Doc Comment
 *
 * @category Class
 * @author   Threema Gateway team
 * @see      https://gateway.threema.ch/en/developer
 */
abstract class ThreemaGroupMessage extends ThreemaMessage
{

	/**
	 * Constructor
	 *
	 */
	public function __construct(
		private readonly GroupId $groupId) {
	}

	public function __toArray(): array
	{
		return array_filter([


		], static fn($v) => Util::array_filter_callback($v));
	}

	/**
	 * Data that can be natively serialized by `json_encode()`.
	 * @return string|array
	 */
	public function jsonSerialize(): string|array
	{
		return $this->__toArray();
	}

	/**
	 * The deserialized ThreemaGroupMessage.
	 *
	 * @throws \Exception
	 */
	public static function fromString(string $data, int $realDataLength, \Closure $piece): ThreemaGroupMessage
	{
		Serializers\ThreemaGroupMessageSerializer::validate($data, $realDataLength);
		return Serializers\ThreemaGroupMessageSerializer::deserialize($data, $piece);
	}

	/**
	 * Show all the invalid properties with reasons.
	 *
	 * @return array invalid properties with reasons
	 */
	public function listInvalidProperties(): array
	{
		$invalidProperties = parent::listInvalidProperties();

		if (null === $this->groupId) {
			$invalidProperties[] = "'groupId' can't be null";
		}
		return $invalidProperties;
	}

	/**
	 * Validate all the properties in the model
	 * return true if all passed
	 *
	 * @return bool True if all properties are valid
	 */
	public function valid(): bool
	{
		return count($this->listInvalidProperties()) === 0;
	}


	/**
	 * Gets groupId
	 *
	 * @return GroupId
	 */
	public function getGroupId(): GroupId
	{
		return $this->groupId;
	}

	/**
	 * Gets the string presentation of the object
	 *
	 * @return string
	 */
	public function __toString(): string
	{
		return 'ThreemaGroupMessage{' . 'groupId=' . $this->groupId . '}';
	}
}
