<?php
/**
 * 
 *
 * PHP version 8.1
 *
 * @category  Class
 * @author    Threema Gateway team
 * @copyright Copyright (c) 2024 Threema GmbH
 * @see       https://gateway.threema.ch/en/developer
 */

/**
 * Threema Gateway Php SDK
 *
 * This SDK allows for preparing, sending, and receiving Threema messages via Threema Gateway.
 *
 * Generated by: https://gateway.threema.ch/en/developer
 * MsgApi SDK Generator version: 0.1.0
 */

namespace Threema\MsgApi\Messages;

/**
 * @deprecated
 */
class VideoMessage extends ThreemaMessage implements \Stringable
{
	final public const TYPE_CODE = 0x13;

	/**
	 * @param string $blobId
	 * @param $blobLength
	 * @param string $thumbnailBlobId
	 * @param $thumbnailLength
	 * @param string $encryptionKey
	 * @param int $duration
	 */
	public function __construct(
		private readonly string $blobId,
		/** @var */
		private                 $blobLength,
		private readonly string $thumbnailBlobId,
		/** @var */
		private                 $thumbnailLength,
		private readonly string $encryptionKey,
		private readonly int    $duration
	) {
	}

	/**
	 * @return string
	 */
	public function __toString(): string
	{
		return 'video message';
	}

	/**
	 * @return string
	 */
	public function getBlobId(): string
	{
		return $this->blobId;
	}

	/**
	 * @return string
	 */
	public function getEncryptionKey(): string
	{
		return $this->encryptionKey;
	}

	/**
	 * @return string
	 */
	public function getThumbnailBlobId(): string
	{
		return $this->thumbnailBlobId;
	}

	/**
	 * @return int|string
	 */
	public function getDuration(): int|string
	{
		return $this->duration;
	}

	/**
	 * @return mixed
	 */
	public function getBlobLength(): mixed
	{
		return $this->blobLength;
	}

	/**
	 * @return mixed
	 */
	public function getThumbnailLength(): mixed
	{
		return $this->thumbnailLength;
	}

	/**
	 * Get the message type code of this message.
	 *
	 * @return int message type code
	 */
	final public function getTypeCode(): int
	{
		return self::TYPE_CODE;
	}
}
